searchData={"items":[{"type":"module","title":"Gamora","doc":"Provides an Ueberauth strategy for authenticating with Amco.","ref":"Gamora.html"},{"type":"module","title":"Setup - Gamora","doc":"Request to Amco IT an application in Amco for you to use.\n\nInclude the provider in your configuration for Ueberauth;\n\n    config :ueberauth, Ueberauth,\n      providers: [\n        amco: { Gamora, [] }\n      ]\n\nThen include the configuration for Amco:\n\n    config :ueberauth, Gamora.OAuth,\n      client_id: System.get_env(\"AMCO_CLIENT_ID\"),\n      client_secret: System.get_env(\"AMCO_CLIENT_SECRET\")\n\nIf you haven't already, setup routes for your request and callback handler\n\n    scope \"/auth\" do\n      pipe_through [:browser, :auth]\n\n      get \"/:provider\", AuthController, :request\n      get \"/:provider/callback\", AuthController, :callback\n    end\n\nCreate an endpoint for the request and callback where you will handle the\n`Ueberauth.Auth` struct:\n\n    defmodule MyApp.AuthController do\n      use MyApp.Web, :controller\n\n      plug Ueberauth\n\n      def callback_phase(%{ assigns: %{ ueberauth_failure: fails } } = conn, _params) do\n        # do things with the failure\n      end\n\n      def callback_phase(%{ assigns: %{ ueberauth_auth: auth } } = conn, params) do\n        # do things with the auth\n      end\n    end\n\nYou can edit the behaviour of the Strategy by including some options when you\nregister your provider.\n\nTo set the `prompt`:\n\n    config :ueberauth, Ueberauth,\n      providers: [\n        amco: { Gamora, [prompt: \"login\"] }\n      ]\n\nTo set the default 'scopes' (permissions):\n\n    config :ueberauth, Ueberauth,\n      providers: [\n        amco: { Gamora, [default_scope: \"openid email phone\"] }\n      ]\n\nDefault is empty (\"openid profile email\").","ref":"Gamora.html#module-setup"},{"type":"function","title":"Gamora.credentials/1","doc":"Includes the credentials from the Amco response.","ref":"Gamora.html#credentials/1"},{"type":"function","title":"Gamora.default_options/0","doc":"","ref":"Gamora.html#default_options/0"},{"type":"function","title":"Gamora.extra/1","doc":"Stores the raw information (including the token) obtained from the Amco\ncallback.","ref":"Gamora.html#extra/1"},{"type":"function","title":"Gamora.handle_cleanup!/1","doc":"Cleans up the private area of the connection used for passing the raw Amco\nresponse around during the callback.","ref":"Gamora.html#handle_cleanup!/1"},{"type":"function","title":"Gamora.handle_request!/1","doc":"Handles the initial redirect to the amco authentication page.\n\nTo customize the scope (permissions) that are requested by amco include\nthem as part of your url:\n\n    \"/auth/amco?scope=openid,profile,email,phone\"","ref":"Gamora.html#handle_request!/1"},{"type":"function","title":"Gamora.info/1","doc":"Fetches the fields to populate the info section of the `Ueberauth.Auth`\nstruct.","ref":"Gamora.html#info/1"},{"type":"function","title":"Gamora.uid/1","doc":"Fetches the `:uid` field from the Amco response.\n\nThis defaults to the option `:uid_field` which in-turn defaults to `:id`","ref":"Gamora.html#uid/1"},{"type":"module","title":"Gamora.API","doc":"This module wraps the functions to access IDP's endpoints.","ref":"Gamora.API.html"},{"type":"function","title":"Gamora.API.introspect/1","doc":"Gets token's data based on an access token using introspection\nendpoint in the IDP.","ref":"Gamora.API.html#introspect/1"},{"type":"function","title":"Parameters - Gamora.API.introspect/1","doc":"- access_token: String [Access token generated by the IDP].","ref":"Gamora.API.html#introspect/1-parameters"},{"type":"function","title":"Examples - Gamora.API.introspect/1","doc":"iex> introspect(\"bGWcAKadGrBwM...\")\n    {:ok, %{active: true, ...}\n\n    iex> introspect(\"InvalidAccessToken\")\n    {:error, :access_token_invalid}","ref":"Gamora.API.html#introspect/1-examples"},{"type":"function","title":"Gamora.API.userinfo/1","doc":"Gets user's data based on an access token using userinfo\nendpoint in the IDP.","ref":"Gamora.API.html#userinfo/1"},{"type":"function","title":"Parameters - Gamora.API.userinfo/1","doc":"- access_token: String [Access token generated by the IDP].","ref":"Gamora.API.html#userinfo/1-parameters"},{"type":"function","title":"Examples - Gamora.API.userinfo/1","doc":"iex> userinfo(\"bGWcAKadGrBwM...\")\n    {:ok, %{email: \"test@example\", phone_number: \"+523344556677\"}}\n\n    iex> userinfo(\"InvalidAccessToken\")\n    {:error, :access_token_invalid}","ref":"Gamora.API.html#userinfo/1-examples"},{"type":"module","title":"Gamora.Cache","doc":"Default Gamora cache implementation.","ref":"Gamora.Cache.html"},{"type":"function","title":"Gamora.Cache.generations/0","doc":"A convenience function for retrieving the current generations.","ref":"Gamora.Cache.html#generations/0"},{"type":"function","title":"Gamora.Cache.new_generation/1","doc":"A convenience function for creating new generations.","ref":"Gamora.Cache.html#new_generation/1"},{"type":"function","title":"Gamora.Cache.newer_generation/0","doc":"A convenience function for retrieving the newer generation.","ref":"Gamora.Cache.html#newer_generation/0"},{"type":"function","title":"Gamora.Cache.reset_generation_timer/0","doc":"A convenience function for reset the GC timer.","ref":"Gamora.Cache.html#reset_generation_timer/0"},{"type":"module","title":"Gamora.Cache.Actions","doc":"This module wraps common caching functions.","ref":"Gamora.Cache.Actions.html"},{"type":"module","title":"Gamora.Cache.Introspect","doc":"This module that allows to get, set and fetch introspection\ndata in the cache in order to improve performance.","ref":"Gamora.Cache.Introspect.html"},{"type":"function","title":"Gamora.Cache.Introspect.del/1","doc":"Deletes introspect cache for the given access token.","ref":"Gamora.Cache.Introspect.html#del/1"},{"type":"function","title":"Parameters - Gamora.Cache.Introspect.del/1","doc":"- access_token: String [Access token from IDP].","ref":"Gamora.Cache.Introspect.html#del/1-parameters"},{"type":"function","title":"Examples - Gamora.Cache.Introspect.del/1","doc":"iex> del(\"ACCESS_TOKEN\")\n    {:ok, true}","ref":"Gamora.Cache.Introspect.html#del/1-examples"},{"type":"function","title":"Gamora.Cache.Introspect.fetch/1","doc":"Returns introspect data for the given access token if\nexists, otherwise it will fetch it and store it.","ref":"Gamora.Cache.Introspect.html#fetch/1"},{"type":"function","title":"Parameters - Gamora.Cache.Introspect.fetch/1","doc":"- access_token: String [Access token from IDP].","ref":"Gamora.Cache.Introspect.html#fetch/1-parameters"},{"type":"function","title":"Examples - Gamora.Cache.Introspect.fetch/1","doc":"iex> fetch(\"ACCESS_TOKEN\")\n    {:ok, %{\"active\" => true, ...}}","ref":"Gamora.Cache.Introspect.html#fetch/1-examples"},{"type":"function","title":"Gamora.Cache.Introspect.get/1","doc":"Returns introspect data for the given access token.","ref":"Gamora.Cache.Introspect.html#get/1"},{"type":"function","title":"Parameters - Gamora.Cache.Introspect.get/1","doc":"- access_token: String [Access token from IDP].","ref":"Gamora.Cache.Introspect.html#get/1-parameters"},{"type":"function","title":"Examples - Gamora.Cache.Introspect.get/1","doc":"iex> get(\"ACCESS_TOKEN\")\n    {:ok, nil}\n\n    iex> get(\"ACCESS_TOKEN\")\n    {:ok, %{\"active\" => true, ...}}","ref":"Gamora.Cache.Introspect.html#get/1-examples"},{"type":"function","title":"Gamora.Cache.Introspect.put/2","doc":"Stores introspect data for the given access token.","ref":"Gamora.Cache.Introspect.html#put/2"},{"type":"function","title":"Parameters - Gamora.Cache.Introspect.put/2","doc":"- access_token: String [Access token from IDP].","ref":"Gamora.Cache.Introspect.html#put/2-parameters"},{"type":"function","title":"Examples - Gamora.Cache.Introspect.put/2","doc":"iex> put(\"ACCESS_TOKEN\", %{\"active\" => true, ...})\n    {:ok, %{\"active\" => true, ...}}","ref":"Gamora.Cache.Introspect.html#put/2-examples"},{"type":"module","title":"Gamora.Cache.Userinfo","doc":"This module that allows to get, set and fetch user's claims\nin the cache in order to improve performance.","ref":"Gamora.Cache.Userinfo.html"},{"type":"function","title":"Gamora.Cache.Userinfo.del/1","doc":"Deletes introspect cache for the given access token.","ref":"Gamora.Cache.Userinfo.html#del/1"},{"type":"function","title":"Parameters - Gamora.Cache.Userinfo.del/1","doc":"- access_token: String [Access token from IDP].","ref":"Gamora.Cache.Userinfo.html#del/1-parameters"},{"type":"function","title":"Examples - Gamora.Cache.Userinfo.del/1","doc":"iex> del(\"ACCESS_TOKEN\")\n    {:ok, true}","ref":"Gamora.Cache.Userinfo.html#del/1-examples"},{"type":"function","title":"Gamora.Cache.Userinfo.fetch/1","doc":"Returns introspect data for the given access token if\nexists, otherwise it will fetch it and store it.","ref":"Gamora.Cache.Userinfo.html#fetch/1"},{"type":"function","title":"Parameters - Gamora.Cache.Userinfo.fetch/1","doc":"- access_token: String [Access token from IDP].","ref":"Gamora.Cache.Userinfo.html#fetch/1-parameters"},{"type":"function","title":"Examples - Gamora.Cache.Userinfo.fetch/1","doc":"iex> fetch(\"ACCESS_TOKEN\")\n    {:ok, %{\"active\" => true, ...}}","ref":"Gamora.Cache.Userinfo.html#fetch/1-examples"},{"type":"function","title":"Gamora.Cache.Userinfo.get/1","doc":"Returns introspect data for the given access token.","ref":"Gamora.Cache.Userinfo.html#get/1"},{"type":"function","title":"Parameters - Gamora.Cache.Userinfo.get/1","doc":"- access_token: String [Access token from IDP].","ref":"Gamora.Cache.Userinfo.html#get/1-parameters"},{"type":"function","title":"Examples - Gamora.Cache.Userinfo.get/1","doc":"iex> get(\"ACCESS_TOKEN\")\n    {:ok, nil}\n\n    iex> get(\"ACCESS_TOKEN\")\n    {:ok, %{\"active\" => true, ...}}","ref":"Gamora.Cache.Userinfo.html#get/1-examples"},{"type":"function","title":"Gamora.Cache.Userinfo.put/2","doc":"Stores introspect data for the given access token.","ref":"Gamora.Cache.Userinfo.html#put/2"},{"type":"function","title":"Parameters - Gamora.Cache.Userinfo.put/2","doc":"- access_token: String [Access token from IDP].","ref":"Gamora.Cache.Userinfo.html#put/2-parameters"},{"type":"function","title":"Examples - Gamora.Cache.Userinfo.put/2","doc":"iex> put(\"ACCESS_TOKEN\", %{\"active\" => true, ...})\n    {:ok, %{\"active\" => true, ...}}","ref":"Gamora.Cache.Userinfo.html#put/2-examples"},{"type":"behaviour","title":"Gamora.ErrorHandler","doc":"The error handler behaviour.","ref":"Gamora.ErrorHandler.html"},{"type":"callback","title":"Gamora.ErrorHandler.access_token_error/2","doc":"This callbacks is called when the access token couldn't be validated\nor the OpenID Connect Provider returned that it was invalid or expired.","ref":"Gamora.ErrorHandler.html#c:access_token_error/2"},{"type":"type","title":"Gamora.ErrorHandler.conn/0","doc":"","ref":"Gamora.ErrorHandler.html#t:conn/0"},{"type":"type","title":"Gamora.ErrorHandler.response/0","doc":"","ref":"Gamora.ErrorHandler.html#t:response/0"},{"type":"module","title":"Gamora.OAuth","doc":"OAuth2 for Amco.\nAdd `:client_id` and `:client_secret` to your configuration:\n    config :ueberauth, Gamora.OAuth,\n      client_id: System.get_env(\"AMCO_APP_ID\"),\n      client_secret: System.get_env(\"AMCO_APP_SECRET\")","ref":"Gamora.OAuth.html"},{"type":"function","title":"Gamora.OAuth.authorize_url/2","doc":"","ref":"Gamora.OAuth.html#authorize_url/2"},{"type":"function","title":"Gamora.OAuth.authorize_url!/2","doc":"Provides the authorize url for the request phase of Ueberauth.\nNo need to call this usually.","ref":"Gamora.OAuth.html#authorize_url!/2"},{"type":"function","title":"Gamora.OAuth.client/1","doc":"Construct a client for requests to Amco.\nThis will be setup automatically for you in `Gamora`.\nThese options are only useful for usage outside the normal callback phase\nof Ueberauth.","ref":"Gamora.OAuth.html#client/1"},{"type":"function","title":"Gamora.OAuth.get_access_token/2","doc":"","ref":"Gamora.OAuth.html#get_access_token/2"},{"type":"function","title":"Gamora.OAuth.get_token/3","doc":"","ref":"Gamora.OAuth.html#get_token/3"},{"type":"function","title":"Gamora.OAuth.introspect/2","doc":"","ref":"Gamora.OAuth.html#introspect/2"},{"type":"function","title":"Gamora.OAuth.userinfo/2","doc":"","ref":"Gamora.OAuth.html#userinfo/2"},{"type":"module","title":"Gamora.Plugs.AuthenticatedUser","doc":"This plug uses different adapters to validate the access token\nprovider in the request. IdpAdapter will do that against the\nIdentity Provider server. In test env you may want to use the\nMockAdapter to avoid making request to the IdP server while the\ntests are running.","ref":"Gamora.Plugs.AuthenticatedUser.html"},{"type":"module","title":"Gamora.Plugs.AuthenticatedUser.IdpAdapter","doc":"This adapter is in charge to verify and validate the access token\nprovided in the request against the OpenID Connect Provider.\nIt will try to get the access token from headers for json requests,\notherwise from cookies.\n\nIf the access token is valid, the current user will be assigned to the\nconnection and the request will continue as normal. In the other hand,\nit will call the access_token_error function in the response handler.","ref":"Gamora.Plugs.AuthenticatedUser.IdpAdapter.html"},{"type":"function","title":"Gamora.Plugs.AuthenticatedUser.IdpAdapter.call/2","doc":"","ref":"Gamora.Plugs.AuthenticatedUser.IdpAdapter.html#call/2"},{"type":"module","title":"Gamora.Plugs.AuthenticatedUser.TestAdapter","doc":"This adapter just returns the connection. The purpose of this module\nis to be used in test environment to avoid making request to the\nidentity provider to authenticate users.","ref":"Gamora.Plugs.AuthenticatedUser.TestAdapter.html"},{"type":"function","title":"Gamora.Plugs.AuthenticatedUser.TestAdapter.call/2","doc":"","ref":"Gamora.Plugs.AuthenticatedUser.TestAdapter.html#call/2"},{"type":"module","title":"Gamora.User","doc":"The user representation.","ref":"Gamora.User.html"},{"type":"type","title":"Gamora.User.t/0","doc":"","ref":"Gamora.User.html#t:t/0"},{"type":"exception","title":"Gamora.Exceptions.MissingAccessTokenSourceOption","doc":"","ref":"Gamora.Exceptions.MissingAccessTokenSourceOption.html"},{"type":"exception","title":"Gamora.Exceptions.MissingErrorHandlerOption","doc":"","ref":"Gamora.Exceptions.MissingErrorHandlerOption.html"},{"type":"exception","title":"Gamora.Exceptions.MissingSiteConfiguration","doc":"","ref":"Gamora.Exceptions.MissingSiteConfiguration.html"},{"type":"extras","title":"Changelog","doc":"# Changelog\n\nAll notable changes to this project will be documented in this file.\n\nThe format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),\nand this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).","ref":"changelog.html"},{"type":"extras","title":"v0.15.0 - Changelog","doc":"* Enhancements:\n  * Add support for `allow_amco_badge` param in the authorization url.","ref":"changelog.html#v0-15-0"},{"type":"extras","title":"v0.14.0 - Changelog","doc":"* Enhancements:\n  * Add option to skip fetching roles when asking for userinfo.","ref":"changelog.html#v0-14-0"},{"type":"extras","title":"v0.13.0 - Changelog","doc":"* Enhancements:\n  * Add support for `associated_user_id` claim.","ref":"changelog.html#v0-13-0"},{"type":"extras","title":"v0.12.2 - Changelog","doc":"* Bug fixes:\n  * Fix else clause in TestAdapter.","ref":"changelog.html#v0-12-2"},{"type":"extras","title":"v0.12.1 - Changelog","doc":"* Enhancements:\n  * Add invalid and required access token cases to the TestAdapter.","ref":"changelog.html#v0-12-1"},{"type":"extras","title":"v0.12.0 - Changelog","doc":"* Enhancements:\n  * Add support for `allow_create` param in the authorization url.","ref":"changelog.html#v0-12-0"},{"type":"extras","title":"v0.11.1 - Changelog","doc":"* Enhancements:\n  * Remove unused alias warning in `IdpAdapter`.","ref":"changelog.html#v0-11-1"},{"type":"extras","title":"0.11.0 - Changelog","doc":"* Deprecations:\n  * Remove `whitelisted_clients` support.","ref":"changelog.html#0-11-0"},{"type":"extras","title":"v0.10.0 - Changelog","doc":"* Enhancements:\n  * Add support for `username` claim.","ref":"changelog.html#v0-10-0"},{"type":"extras","title":"v0.9.0 - Changelog","doc":"* Enhancements:\n  * Verify access token using introspect endpoint instead userinfo.\n  * Add `introspect_cache_expires_in` config to avoid hitting the IDP\n    every request. Default value is `:timer.seconds(0)`.\n  * New default value for `userinfo_cache_expires_in` config. Now,\n    the default value is `:timer.seconds(60)`.\n  * Add `whitelisted_clients` config to accept access tokens ONLY\n    from trusted clients. Default value is the same client.\n\n* Breaking changes:\n  * If your application is accepting access tokens from other IDP\n    clients you must set the `whitelisted_clients` config with\n    the client ids that are whitelisted. Otherwise, the application\n    is gonna accept access tokens ONLY from the same client id.","ref":"changelog.html#v0-9-0"},{"type":"extras","title":"v0.8.0 - Changelog","doc":"* Enhancements:\n  * Add support for `roles` claim.","ref":"changelog.html#v0-8-0"},{"type":"extras","title":"v0.7.0 - Changelog","doc":"* Enhancements:\n  * Add support for `email_verified` and `phone_number_verified` claims.","ref":"changelog.html#v0-7-0"},{"type":"extras","title":"v0.6.0 - Changelog","doc":"* Enhancements:\n  * Add support for `max_age` param in the authorization url.","ref":"changelog.html#v0-6-0"},{"type":"extras","title":"v0.5.1 - Changelog","doc":"* Bug fixes:\n  * Fix ExDocs according to the new library name.","ref":"changelog.html#v0-5-1"},{"type":"extras","title":"v0.5.0 - Changelog","doc":"* Enhancements:\n  * Add support for `branding` param in the authorization url.","ref":"changelog.html#v0-5-0"},{"type":"extras","title":"v0.4.0 - Changelog","doc":"* Enhancements:\n  * Add support for `theme` param in the authorization url.","ref":"changelog.html#v0-4-0"},{"type":"extras","title":"v0.3.0 - Changelog","doc":"* Enhancements:\n  * Improve plug adapters.\n  * Add IdpAdapter and MockAdapter.","ref":"changelog.html#v0-3-0"},{"type":"extras","title":"v0.2.0 - Changelog","doc":"* Enhancements:\n  * Add Gamora.User structure to represent user claims.","ref":"changelog.html#v0-2-0"},{"type":"extras","title":"v0.1.0 - Changelog","doc":"* Initial version of the ueberauth strategy for amco.","ref":"changelog.html#v0-1-0"},{"type":"extras","title":"Contributing to Gamora","doc":"# Contributing to Gamora","ref":"contributing.html"},{"type":"extras","title":"Pull Requests Welcome - Contributing to Gamora","doc":"1. Fork gamora\n2. Create a topic branch\n3. Make logically-grouped commits with clear commit messages\n4. Push commits to your fork\n5. Open a pull request against gamora/main","ref":"contributing.html#pull-requests-welcome"},{"type":"extras","title":"Issues - Contributing to Gamora","doc":"If you believe there to be a bug, please provide the maintainers with enough\ndetail to reproduce or a link to an app exhibiting unexpected behavior. For\nhelp, please start with Stack Overflow.","ref":"contributing.html#issues"},{"type":"extras","title":"Gamora","doc":"# Gamora\n\n> Amco OpenID Connect strategy for Überauth.","ref":"readme.html"},{"type":"extras","title":"Installation - Gamora","doc":"1.  Setup your application at Amco OIDC Provider.\n\n2.  Add `:gamora` to your list of dependencies in `mix.exs`:\n\n    ```elixir\n    def deps do\n      [\n        {:gamora, \"~> 0.14\"}\n      ]\n    end\n    ```\n\n3.  Add Gamora to your Überauth configuration:\n\n    ```elixir\n    config :ueberauth, Ueberauth,\n      providers: [\n        amco: {Gamora, []}\n      ]\n    ```\n\n4.  Update your provider configuration:\n\n    Example 1: Using environment variables at compile time:\n\n    ```elixir\n    config :ueberauth, Gamora.OAuth,\n      site: System.get_env(\"AMCO_IDP_URL\"),\n      client_id: System.get_env(\"AMCO_CLIENT_ID\"),\n      client_secret: System.get_env(\"AMCO_CLIENT_SECRET\")\n    ```\n\n    Example 2: Using environment variables from a runtime file:\n\n    ```elixir\n    config :ueberauth, Gamora.OAuth,\n      site: {System, :get_env, [\"AMCO_IDP_URL\"]},\n      client_id: {System, :get_env, [\"AMCO_CLIENT_ID\"]},\n      client_secret: {System, :get_env, [\"AMCO_CLIENT_SECRET\"]}\n    ```\n\n    Example 3: Using strings in a managed file at runtime:\n\n    ```elixir\n    config :ueberauth, Gamora.OAuth,\n      site: \"https://my_idp.example.com\",\n      client_id: \"my client id\",\n      client_secret: \"my client secret\"\n    ```\n\n5.  Include the Überauth plug in your controller:\n\n    ```elixir\n    defmodule MyAppWeb.AuthController do\n      use MyAppWeb, :controller\n\n      plug Ueberauth\n      ...\n    end\n    ```\n\n6.  Create the request and callback routes if you haven't already:\n\n    ```elixir\n    scope \"/auth\", MyAppWeb do\n      pipe_through :browser\n\n      get \"/logout\", AuthController, :logout\n      get \"/:provider\", AuthController, :request\n      get \"/:provider/callback\", AuthController, :callback\n\n      # If your app is a JSON API, you'll want to exchange the\n      # authorization code using a POST request.\n      post \"/:provider/callback\", AuthController, :callback\n    end\n    ```\n\n7.  Your controller needs to implement callbacks to deal with `Ueberauth.Auth` and `Ueberauth.Failure` responses.\n\nFor an example implementation see the [Überauth Example](https://github.com/ueberauth/ueberauth_example) application.","ref":"readme.html#installation"},{"type":"extras","title":"Callbacks - Gamora","doc":"","ref":"readme.html#callbacks"},{"type":"extras","title":"Web-based applications - Gamora","doc":"For web-based applications you should add the auth response to the\nsession and redirect the user to the path you want. Your callbacks in\nthe auth controller should look like this:\n\n```elixir\ndefmodule MyAppWeb.AuthController do\n  use MyAppWeb, :controller\n\n  plug Ueberauth\n\n  def callback(%{assigns: %{ueberauth_failure: _fails}} = conn, _params) do\n    conn\n    |> put_flash(:error, \"Failed to authenticate.\")\n    |> redirect(to: redirect_path(conn))\n  end\n\n  def callback(%{assigns: %{ueberauth_auth: auth}} = conn, _params) do\n    conn\n    |> put_flash(:info, \"Successfully authenticated.\")\n    |> put_session(:access_token, auth.credentials.token)\n    |> put_session(:refresh_token, auth.credentials.refresh_token)\n    |> configure_session(renew: true)\n    |> redirect(to: redirect_path(conn))\n  end\n\n  defp redirect_path(conn) do\n    get_session(conn, :original_url) || \"/\"\n  end\nend\n```","ref":"readme.html#web-based-applications"},{"type":"extras","title":"JSON API applications - Gamora","doc":"For JSON API applications you should return the access token, refresh\ntoken and id token to the native application that is consuming the API.\nYour callbacks in the auth controller should look like this:\n\n```elixir\ndefmodule MyAppWeb.AuthController do\n  use MyAppWeb, :controller\n\n  plug Ueberauth\n\n  def callback(%{assigns: %{ueberauth_failure: fails}} = conn, _params) do\n    conn\n    |> put_status(:unauthorized)\n    |> json(%{\n      message: fails.message,\n      message_key: fails.message_key\n    })\n  end\n\n  def callback(%{assigns: %{ueberauth_auth: auth}} = conn, _params) do\n    conn\n    |> json(%{\n      access_token: auth.credentials.token,\n      id_token: auth.credentials.other[\"id_token\"],\n      refresh_token: auth.credentials.refresh_token\n    })\n  end\n\n  def logout(conn, _params) do\n    conn\n    |> put_session(:access_token, nil)\n    |> put_session(:refresh_token, nil)\n    |> redirect(to: ~p\"/auth/amco?max_age=0\")\n  end\nend\n```","ref":"readme.html#json-api-applications"},{"type":"extras","title":"Protected Routes - Gamora","doc":"Protecting a route means that incoming requests should contain an\naccess token. That access token will be validated against the\nIdentity Provider to verify it has not expired and is still valid.\nIf the access token is valid, you will have the current user in the\n`conn.assigns[:current_user]` based on the claims returned by de IdP.\nOtherwise the error handler will be called and the connection must be\nhalted.","ref":"readme.html#protected-routes"},{"type":"extras","title":"Web-based applications - Gamora","doc":"Use the plug `Gamora.Plugs.AuthenticatedUser` in\nyour protected routes. This will get the access token from session\nand validate it against the IDP (OIDC Identity Provider).\n\n```elixir\ndefmodule MyAppWeb.Router do\n  use MyAppWeb, :router\n\n  pipeline :protected do\n    plug Gamora.Plugs.AuthenticatedUser,\n      error_handler: MyAppWeb.AuthenticationErrorHandler,\n      access_token_source: :session\n  end\n\n  scope \"/\", MyAppWeb do\n    pipe_through [:browser, :protected]\n\n    # Add your protected routes here\n  end\nend\n```\n\nAnd define your callbacks module in your application. It may look\nsomething like the following in a phoenix application:\n\n```elixir\ndefmodule MyAppWeb.AuthenticationErrorHandler do\n  @behaviour Gamora.ErrorHandler\n\n  import Plug.Conn, only: [halt: 1, put_session: 3]\n  import Phoenix.Controller, only: [redirect: 2]\n\n  @impl Gamora.ErrorHandler\n  def access_token_error(conn, error) do\n    conn\n    |> put_session(:original_url, conn.request_path)\n    |> redirect(to: \"/auth/amco\")\n    |> halt()\n  end\nend\n```","ref":"readme.html#web-based-applications"},{"type":"extras","title":"JSON API applications - Gamora","doc":"If your app requires json response you'll need to add `access_token_source: :headers`\nto the plug options. It will get the access token from the request\nheader `Authorization: Bearer  `.\n\n```elixir\ndefmodule MyAppWeb.Router do\n  use MyAppWeb, :router\n\n  pipeline :protected do\n    plug Gamora.Plugs.AuthenticatedUser,\n      error_handler: MyAppWeb.AuthenticationErrorHandler,\n      access_token_source: :headers\n  end\nend\n```\n\nAnd then update your `ErrorHandler` to response with a json. It may\nlook something like this:\n\n```elixir\ndefmodule MyAppWeb.AuthenticationErrorHandler do\n  @behaviour Gamora.ErrorHandler\n\n  import Plug.Conn\n  import Phoenix.Controller\n\n  @impl Gamora.ErrorHandler\n  def access_token_error(conn, error) do\n    conn\n    |> put_status(:unauthorized)\n    |> json(%{error: error})\n    |> halt()\n  end\nend\n```","ref":"readme.html#json-api-applications"},{"type":"extras","title":"Calling - Gamora","doc":"Depending on the configured url you can initiate the request through:\n\n    /auth/amco\n\nOr with options:\n\n    /auth/amco?scope=email%20profile&strategy=phone_number\n\nBy default the requested scope is `openid profile email`. Scope can be configured\neither explicitly as a `scope` query value on the request path or in your\nconfiguration:\n\n```elixir\nconfig :ueberauth, Ueberauth,\n  providers: [\n    amco: {Gamora, [default_scope: \"openid email phone\"]}\n  ]\n```\n\nBy default the strategy to be used is `default`. Strategy can be configured\neither explicitly as a `strategy` query value on the request path or in your\nconfiguration:\n\n```elixir\nconfig :ueberauth, Ueberauth,\n  providers: [\n    amco: {Gamora, [default_strategy: \"phone_number\"]}\n  ]\n```\n\nBy default the theme to be used is `default`. Theme can be configured\neither explicitly as a `theme` query value on the request path or in your\nconfiguration:\n\n```elixir\nconfig :ueberauth, Ueberauth,\n  providers: [\n    amco: {Gamora, [default_theme: \"dark_blue\"]}\n  ]\n```\n\nBy default the brand to be used is `amco`. Branding can be configured\neither explicitly as a `branding` query value on the request path or in your\nconfiguration:\n\n```elixir\nconfig :ueberauth, Ueberauth,\n  providers: [\n    amco: {Gamora, [default_branding: \"amco\"]}\n  ]\n```\n\nBy default IDP will allow users to create new accounts. Account creation\ncan be configured either explicitly as a `allow_create` query value on the\nrequest path or in your configuration:\n\n```elixir\nconfig :ueberauth, Ueberauth,\n  providers: [\n    amco: {Gamora, [default_allow_create: false]}\n  ]\n```\n\nBy default IDP won't allow users to sign in with Amco badge. Amco badge\nstrategy can be configured either explicitly as a `allow_amco_badge`\nquery value on the request path or in your configuration:\n\n```elixir\nconfig :ueberauth, Ueberauth,\n  providers: [\n    amco: {Gamora, [default_allow_amco_badge: true]}\n  ]\n```\n\nBy default prompt is not present in the authorization url. Prompt can be\nconfigured either explicitly as a `prompt` query value on the request\npath or in your configuration:\n\n```elixir\nconfig :ueberauth, Ueberauth,\n  providers: [\n    amco: {Gamora, [default_prompt: \"login\"]}\n  ]\n```\n\nTo guard against client-side request modification, it's important to still\ncheck the domain in `info.urls[:website]` within the `Ueberauth.Auth` struct\nif you want to limit sign-in to a specific domain.","ref":"readme.html#calling"},{"type":"extras","title":"Caching - Gamora","doc":"In order to avoid performing requests to the IDP on each request in the\napplication, it is possible to set a caching time for introspection and\nuserinfo endpoints. Make sure to not have a too long expiration time for\n`introspect_cache_expires_in` but not too short to impact the application\nperformance, it is a balance.\n\n```elixir\nconfig :ueberauth, Gamora.Plugs.AuthenticatedUser,\n  introspect_cache_expires_in: :timer.seconds(0), # Default value\n  userinfo_cache_expires_in: :timer.minutes(1)    # Default value\n```\n\nThen, add `Gamora.Cache` in `lib/my_app/application.ex`:\n\n```elixir\ndefmodule MyApp.Application do\n  use Application\n\n  @impl true\n  def start(_type, _args) do\n    children =\n      [\n        Gamora.Cache,\n        ...\n      ]\n    ...\n```","ref":"readme.html#caching"},{"type":"extras","title":"Custom Cache Adapter - Gamora","doc":"By default, Gamora uses `Gamora.Cache` which uses the `Nebulex.Adapters.Local`.\nCustom Nebulex cache module can be used in your application passing the\n`cache_adapter` configuration:\n\n```elixir\nconfig :ueberauth, Gamora.Plugs.AuthenticatedUser,\n  cache_adapter: MyApp.Cache\n```","ref":"readme.html#custom-cache-adapter"},{"type":"extras","title":"Testing - Gamora","doc":"In test environment you should avoid making requests to authenticate\nusers in protected routes. In order to do that, you can configure the\n`TestAdapter` for the `AuthenticatedUser` plug in your `config/test.exs`:\n\n```elixir\nconfig :ueberauth, Gamora.Plugs.AuthenticatedUser,\n  adapter: Gamora.Plugs.AuthenticatedUser.TestAdapter\n```","ref":"readme.html#testing"},{"type":"extras","title":"Copyright and License - Gamora","doc":"Copyright (c) 2022 Amco\n\nReleased under the MIT License, which can be found in the repository in\n[LICENSE](https://github.com/amco/gamora-ex/blob/master/LICENSE).","ref":"readme.html#copyright-and-license"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.3"}}